Emi.ns('Emi.serverTime');
Emi.serverTime = {
	  _diff: 0,
	  _control: null,
	  _interval: null,
	  render: function() {
	    var cTime = new Date();
	    var sTime = new Date(cTime.setMilliseconds(cTime.getMilliseconds() - Emi.serverTime._diff));
	    Emi.serverTime._control.html('Sistem Saati : ' + Emi.util.date.formatDateTime(sTime));
	  },
	  start: function(t, t_$elem) {
	    if(this._interval) {
	      clearInterval(this._interval);
	      this._diff = 0;
	    }
	    var sTime = Emi.util.date.parseDataDate(t);
	    var cTime = new Date();
	    this._diff = cTime - sTime;
	    this._control = t_$elem || $('#serverClockTime');
	    this._control.html('Sistem Saati : ' + Emi.util.date.formatDateTime(sTime)).show();
	    this._interval = setInterval(this.render, 1000);
	  },
	  stop: function() {
	    clearInterval(this._interval);
	  }
	  ,getDate:function(){
		  var cTime = new Date();
		  cTime.setMilliseconds(cTime.getMilliseconds() - this._diff);
		  return cTime;
	  },
	  getUnixtimestamp:function(){
		  var cTime = new Date();
		  var sTime = new Date(cTime.setMilliseconds(cTime.getMilliseconds() - Emi.serverTime._diff));
		  
		  return Math.round(sTime.getTime() / 1000);
	  },
	  getHumanTime:function(t_date){
		  var date = Emi.util.date.parse(t_date);
		  var strTime = (date.getHours().toString().length>1?date.getHours():"0"+date.getHours())+":"+(date.getMinutes().toString().length>1?date.getMinutes():"0"+date.getMinutes())+":"+(date.getSeconds().toString().length>1?date.getSeconds():"0"+date.getSeconds());
		  var strDate = (date.getDate().toString().length>1?date.getDate():"0"+date.getDate())+"."+((date.getMonth()+1).toString().length>1?(date.getMonth()+1):"0"+(date.getMonth()+1))+"."+date.getFullYear()+ ' '+strTime;

		  var dif = Emi.serverTime.getDate().getTime()-date.getTime();
		  if(dif<1000){
			  dif=1000;
		  }
		  var digit = Math.floor(dif/31536000000);
		  if(digit > 0){
			  return {htime:digit+" years ago",date:strDate};
		  }
		  digit = Math.floor(dif/2592000000);
		  if(digit > 0){
			  return {htime:digit+" months ago",date:strDate};
		  }
		  digit = Math.floor(dif/604800000);
		  if(digit > 0){
			  return {htime:digit+" weeks ago",date:strDate};
		  }
		  digit = Math.floor(dif/86400000);
		  if(digit > 0){
			  if(digit == 1){
				  return {htime:"yesterday",date:strDate};
			  }
			  return {htime:digit+" days ago",date:strDate};
		  }
		  digit = Math.floor(dif/3600000);
		  if(digit > 0){
			  return {htime:digit+" hours ago",date:strDate};
		  }
		  digit = Math.floor(dif/60000);
		  if(digit > 0){
			  return {htime:digit+" minutes ago",date:strDate};
		  }
		  digit = Math.floor(dif/1000);
		  return {htime:digit+" seconds ago",date:strDate};
	  }
	}