jQuery(document).ready(function( ) {
	Emi.page.initTime();
	jQuery('#referenceEmiPrivateMessages textarea').focus(function(){
		var $this = jQuery(this);
        if ($this.val() == $this.attr('title')){
            $this.val("").css('color','black');
        }
    }).blur(function(){
    	var $this = jQuery(this);
        if ($this.val().length==0){
            $this.val($this.attr('title')).css('color','#AAAAAA');
        }
    }).elastic();
	

	jQuery("#referenceSendNewMessage").submit(function(){
		var $this = jQuery(this);
		var $submit = $this.find('input[type="submit"]').hide();
		var $indicator = $this.find('.selectorIndicator').show();
		var $report = $this.find('.selectorReport').hide();
		var $textarea = $this.find('textarea').attr('readonly','readonly');
		jQuery.ajax({
			url: $this.attr('action'),
			data:$this.serialize(),
			type:'POST',
			dataType: 'JSON',
			success:function(response){
				if(response.success){
					$textarea.removeAttr('readonly').val($textarea.attr('title')).css('color','#AAAAAA');;
					$report.css('color','green').html(response.report).show();
					window.location.href=$this.attr('href').replace('%d',response.partnerId);
				}
				else{
					$report.css('color','red').html(response.report).show();
				}
				$indicator.hide();
				$submit.show();
				$textarea.removeAttr('readonly');
            }
		});
				
		return false;
	});
	
	
	var fnInitMessage = function(){
		jQuery('#referenceEmiPrivateMessages .selectorMessage:not(.selectorInited)').mouseover(function(){
			var $this = jQuery(this);
			$this.css('background-color','#EEEEEE');
			$this.find('.selectorDelete').show();
		}).mouseout(function(){
			var $this = jQuery(this);
			$this.css('background-color','white');
			$this.find('.selectorDelete').hide();
		}).addClass('selectorInited');
		
		jQuery('#referenceEmiPrivateMessages .selectorDelete:not(.selectorInited)').click(function(){
			var $this = jQuery(this);
			$indicator = $this.next();
			$message = $this.closest('.selectorMessage');
			$this.remove();
			$indicator.show();
			jQuery.ajax({
				url: $this.attr('href'),
				type:'GET',
				dataType: 'JSON',
				success:function(response){
					$indicator.hide();
					
					$message.hide('slow',function(){
						$message.remove();
					});
					
	            }
			});
			return false;
		}).addClass('selectorInited');
	}
	fnInitMessage();
	var $emiPrivateMessages_send = jQuery('#referenceEmiPrivateMessages_send');
	if($emiPrivateMessages_send.length>0){
	$recipient = jQuery( "#referenceEmiPrivateMessages .selectorRecipient" );

		$recipientAvatar = jQuery('#referenceRecipientAvatar');
		$recipient.focus(function(){
			var $this = jQuery(this);
	        if ($this.val() == $this.attr('title')){
	            $this.val("").css('color','black');
	        }
	    }).blur(function(){
	    	var $this = jQuery(this);
	        if ($this.val().length==0){
	            $this.val($this.attr('title')).css('color','#AAAAAA');
	        }
	    });
		$recipient.autocomplete({
			source: $recipient.attr('href'),
			minLength: 1,
			width:200,
			select: function( event, ui ) {
				$recipientAvatar.html(ui.item.avatar);
			},
			open: function() { 
				$recipient.autocomplete("widget").width(200);
		    }  
		}).data( "autocomplete" )._renderItem = function( ul, item ) {
			return jQuery( "<li></li>" )
			.data( "item.autocomplete", item )
			.append( '<a style="padding:0;"><div style="height:34px;margin:2px;"><span style="float:left;">'+ item.avatar + '</span><span style="margin:5px;">'+item.label + '</span></div></a>' )
			.appendTo( ul );
		}
	}

	
	var $emiPrivateMessages_dialog = jQuery('#referenceEmiPrivateMessages_dialog');
	if($emiPrivateMessages_dialog.length>0){
		
		var intAvailableHeight = jQuery(window).height()-320;
		var $dialog = jQuery( "#referenceDialog" );
		var $getDialogPage = jQuery( "#referenceGetDialogPage" );
		
		if($dialog.height()>intAvailableHeight){
			$dialog.height(intAvailableHeight);
			$dialog.scrollTop($dialog[0].scrollHeight-$dialog.height());
		}
		var intPage=1;
		var $pageIndicator = jQuery( "#referenceDialog .selectorPageIndicator");
		var bolHasMoreMessages=jQuery( "#referenceDialog .selectorMessage").length>=10?true:false;
		
		$dialog.scroll(function(){
			if(!bolHasMoreMessages)return;
			if($dialog.scrollTop()==0){
				intPage++;
				$pageIndicator.show();
				jQuery.ajax({
					url: $getDialogPage.attr('action'),
					data:{page:intPage},
					type:'GET',
					dataType: 'JSON',
					success:function(response){
						if(response.success){
							var intTempHeight = $dialog[0].scrollHeight;
							$pageIndicator.closest('.selectorPad').after(response.messages);
							Emi.page.initTime();
							intTempHeight = $dialog[0].scrollHeight-intTempHeight-30;
							$dialog.scrollTop(intTempHeight);
							if(response.totalMessages<=jQuery( "#referenceDialog .selectorMessage").length){
								bolHasMoreMessages=false;
							}
							fnInitMessage();
						}
						$pageIndicator.hide();
		            }
				});
			}
		});
		
		
		var $getNewDialogMessages = jQuery( "#referenceGetNewDialogMessages" );
		var bolGetNewDialogMessagesProcessing = false;
		var arTemp = $getNewDialogMessages.attr('title').split('-');
		var intGetNewDialogMessagesDelay = parseInt(arTemp[0],10)*1000;
		var intGetNewDialogMessageLastId = parseInt(arTemp[1],10);
		var fnGetNewDialogMessages = function(){
			bolGetNewDialogMessagesProcessing=true;
			jQuery.ajax({
				url: $getNewDialogMessages.attr('action'),
				type:'GET',
				dataType: 'JSON',
				data:{lastId:intGetNewDialogMessageLastId},
				success:function(response){
					if(response.success){
						if(response.newMessages>0){
							intGetNewDialogMessageLastId = response.lastId;
							$dialog.append(response.messages);
							fnInitMessage();
							Emi.page.initTime();
							$dialog.scrollTop($dialog[0].scrollHeight);
							
						}
					}
					getNewDialogMessagesTimeout = window.setTimeout(fnGetNewDialogMessages,intGetNewDialogMessagesDelay);
					bolGetNewDialogMessagesProcessing=false;
	            }
			});
		}
		var getNewDialogMessagesTimeout = window.setTimeout(fnGetNewDialogMessages,intGetNewDialogMessagesDelay);
		
		jQuery("#referenceSendNewDialogMessage").submit(function(){
			var $this = jQuery(this);
			var $submit = $this.find('input[type="submit"]').hide();
			var $indicator = $this.find('.selectorIndicator').show();
			var $report = $this.find('.selectorReport').hide();
			var $textarea = $this.find('textarea').attr('readonly','readonly');
			jQuery.ajax({
				url: $this.attr('action'),
				data:$this.serialize(),
				type:'POST',
				dataType: 'JSON',
				success:function(response){
					if(response.success){
						$textarea.removeAttr('readonly').val($textarea.attr('title')).css('color','#AAAAAA');;
						$report.css('color','green').html(response.report).show();
						if(!bolGetNewDialogMessagesProcessing){
							window.clearTimeout(getNewDialogMessagesTimeout);
							fnGetNewDialogMessages();
						}
					}
					else{
						$report.css('color','red').html(response.report).show();
					}
					$indicator.hide();
					$submit.show();
					$textarea.removeAttr('readonly');
	            }
			});
					
			return false;
		});
		
	}
	
	var $emiPrivateMessages_inbox = jQuery('#referenceEmiPrivateMessages_inbox');
	if($emiPrivateMessages_inbox.length>0){
		(function(){
			var $getNewInboxMessages = jQuery('#referenceGetNewInboxMessages') ;
			var bolGetNewInboxMessagesProcessing = false;
			var arTemp = $getNewInboxMessages.attr('title').split('-');
			var intGetNewInboxMessagesDelay = parseInt(arTemp[0],10)*1000;
			var intGetNewInboxMessageLastId = parseInt(arTemp[1],10);
			var fnGetNewInboxMessages = function(){
				bolGetNewInboxMessagesProcessing=true;
				jQuery.ajax({
					url: $getNewInboxMessages.attr('action'),
					data:{lastId:intGetNewInboxMessageLastId,dialogUrl:$getNewInboxMessages.attr('href')},
					type:'GET',
					dataType: 'JSON',
					success:function(response){
						if(response.success){
							if(response.newMessages>0){
								intGetNewInboxMessageLastId = response.lastId;
								if($emiPrivateMessages_inbox.find('.selectorInboxMessage').length==0){
									$emiPrivateMessages_inbox.find('.selectorContentContainer > ul').html('');
								}
								for(var i=response.messages.length-1;i>=0;i--){
									var eMessage = response.messages[i];
									$currentMessage = $emiPrivateMessages_inbox.find('.selectorInboxMessage_'+eMessage._key);
									if($currentMessage.length>0){
										$currentMessage.remove();
									}
									$emiPrivateMessages_inbox.find('.selectorContentContainer > ul').prepend(eMessage.message);
								}
								Emi.page.initTime();
							}
						}
						getNewInboxMessagesTimeout = window.setTimeout(fnGetNewInboxMessages,intGetNewInboxMessagesDelay);
						bolGetNewInboxMessagesProcessing=false;
		            }
				});
			}
			var getNewInboxMessagesTimeout = window.setTimeout(fnGetNewInboxMessages,intGetNewInboxMessagesDelay);
		})();
		
		Emi.lib.ui.pager({
			pad:jQuery('#referenceEmiPrivateMessages .selectorPagination'),
			contentPad:jQuery('#referenceEmiPrivateMessages .selectorContentContainer'),
			url:jQuery('#referenceGetInboxPage').attr('action'),
			params:{dialogUrl:jQuery('#referenceGetInboxPage').attr('href')},
			animation:true,
			callback:function(){
				Emi.page.initTime();
			}
		});
		
	}

	
	
	

	
	
});


