Emi.ns('Emi.util');
Emi.util = {
	merge_sort:function(array,comparison){if(array.length<2)return array;var middle=Math.ceil(array.length/2);return Emi.util.merge(Emi.util.merge_sort(array.slice(0,middle),comparison),Emi.util.merge_sort(array.slice(middle),comparison),comparison)},
	merge:function(left,right,comparison){var result=new Array();while((left.length>0)&&(right.length>0)){if(comparison(left[0],right[0])<0)result.push(left.shift());else result.push(right.shift())}while(left.length>0)result.push(left.shift());while(right.length>0)result.push(right.shift());return result},
	object:{
		isEmpty:function(t_obj){
			for(var eObj in t_obj){
				return false;
			}
			return true;
		}
	},
	form:{
		submit:function(t_obj){
			var tForm = document.createElement("form");
			tForm.setAttribute("action", t_obj.action);
			tForm.setAttribute("method", "POST");
			if(t_obj.target)tForm.setAttribute("target", t_obj.target);
			for(var property in t_obj.items){
				var tItem =document.createElement("input");
				tItem.setAttribute("type", "hidden");
				tItem.setAttribute("name", property);
				tItem.setAttribute("value", t_obj.items[property]);
				tForm.appendChild(tItem);
			}
			document.body.appendChild(tForm);
			tForm.submit();
		}
	}
	,integer:{
		currency:function(n){
		  n=n.toString().replace(/[^0-9]/ig,'');
		  if(n.length<1)n="0";
		  n=parseInt(n,10).toString();
		  var tA=[];
		  for(var i=1,tL=n.length;i<=tL;i++){
		    tA.push(n.charAt(tL-i));
		    if((i)%3==0 && tL>i)tA.push(".");
		  }
		  tA.reverse();
		  return tA.join('');
		}
		,formatNumber:function (n,d){if(isNaN(parseInt(n,10)))return"NaN";if(0!==d)d=d||2;n=Math.round(parseFloat(n.toString().replace(',','.'))*100)/100;var s=n<0?'-':'';var p=(n>0?n.toFixed(d):(-1*n).toFixed(d)).split('.');var t=p[0];for(i=t.length-3;i>=1;i=i-3)t=t.substring(0,i)+"."+t.substring(i,t.length);return s+t+(p[1]?','+p[1]:'');}
		,formatNumberFloor:function(n, d){if (isNaN(parseInt(n,10))){return "NaN";};d = d || 2;n = Math.floor(parseFloat(n.toString().replace(',','.'))*100)/100;var s = n < 0 ? '-' : '';var p = (n > 0 ? n.toFixed(d) : (-1 * n).toFixed(d)).split('.');var t = p[0];for(i=t.length-3;i>=1;i=i-3){t = t.substring(0,i) + "." + t.substring(i,t.length);};return s+t+','+p[1];}
	}
	,str:{
		fixTr:function(t_value){
			var tr =['ç','Ç','ğ','Ğ','ı','İ','ö','Ö','ş','Ş','ü','Ü'];
			var fix =['c','C','g','G','i','I','o','O','s','S','u','U'];
			for(i=0;i<tr.length;i++)t_value=t_value.replace(tr[i],fix[i]);
			return t_value;
		},
		toHash: function(s) {
			var h = 0;
			var i = 0;
			var c;
			if (s.length === 0) {
				return h;
			}
			for (i = 0; i < s.length; i++) {
				c = s.charCodeAt(i);
				h = 31*h+c;
				h = h & h;
			}
			return h;
		}
	}
	,template:function(t_obj,t_text){
		return t_text.replace(/{([^{}]+)}/ig,function(){
			var prop = arguments[1].match(/^([^\[]+)/);
			var props = arguments[1].match(/\[([^\[\]]+)\]/);
			var result = t_obj[prop[1]];
			if(!props)return result;
			for(var i=1;i<props.length;i++){
				result=result[props[i]] == null ? '' : result[props[i]];
			}
			return result;
		})
	},
	math:{
		consecutiveTotal:function(t_number){
			return t_number*(t_number+1)/2;
		},
		factorial:function(t_number){
			if(t_number==0)return 1;
			var result=t_number;
			while(t_number>1){
				t_number--;
				result*=t_number;
			}
			return result;
		},
		combination:function(t_number, t_combination){
			return Emi.util.math.factorial(t_number)/(t_combination*Emi.util.math.factorial(t_number-t_combination));
		},
		comb:function(n,r){if((r==0)||(r==n))return 1;else if((r>n)||(r<0))return 0;else{var k=n-r,t;if(r<k){i=r;r=k;k=i}t=1;while(k>1)t*=k--;var t2=1;while(n>r)t2*=n--;t=t2/t;return t}}
	},
	date:{
		months:['Ocak','Şubat','Mart','Nisan','Mayıs','Haziran','Temmuz','Ağustos','Eylül','Ekim','Kasım','Aralık'],
		days:['Pazar','Pazartesi','Salı','Çarşamba','Perşembe','Cuma','Cumartesi'],
		parseDataDate:function(d){if(d!=undefined){var t,x=[0,0,0];if(d.toString().indexOf(' ')>-1){var p=d.toString().split(' ');t=p[0].split('-');x=p[1].split(':');if(x.length<3)x.push(0)}else t=d.toString().split('-');return new Date(t[0],t[1]-1,t[2],x[0],x[1],x[2])}},
		formatDate:function(d){if(d!=undefined){var t,s='',x=Emi.util.date.parseDataDate(d);if(d.toString().indexOf(' ')>-1){var p=d.toString().split(' ');t=p[0].split('-');s=p[1].substring(0,5)}else t=d.toString().split('-');return t[2]+' '+Emi.util.date.months[t[1]-1]+' '+t[0]+', '+Emi.util.date.days[x.getDay()]+" "+s;}},
		formatDateTime:function(dt){return(dt.getDate()<10?'0':'')+dt.getDate()+'.'+(dt.getMonth()+1<10?'0':'')+(dt.getMonth()+1)+'.'+dt.getFullYear()+' '+(dt.getHours()<10?'0':'')+dt.getHours()+':'+(dt.getMinutes()<10?'0':'')+dt.getMinutes()+':'+(dt.getSeconds()<10?'0':'')+dt.getSeconds()},
		fromTimestamp:function(t_timestamp){
			return new Date(t_timestamp*1000);
		},
		parse:function(d){
			if(d!=undefined){
				var t=[0,0,0];
				var x=[0,0,0];
				if(d.toString().indexOf(' ')>-1){
					var p=d.toString().split(' ');
					if(p[0].match(/^[0-9]{4}\-[0-9]{2}\-[0-9]{2}/)){
						t=p[0].split('-');
					}
					else if(p[0].match(/^[0-9]{2}\.[0-9]{2}\.[0-9]{4}/)){
						var tt=p[0].split('.');
						t[0]=tt[2];
						t[1]=tt[1];
						t[2]=tt[0];
					}
					else{
						return false;
					}
					x=p[1].split(':');
					if(x.length<3){
						x.push(0)
					}
				}
				else{
					t=d.toString().split('-');
				}
				return new Date(t[0],t[1]-1,t[2],x[0],x[1],x[2])
			}
			return false;
		}
	}
};