<div class="wrap">
	<h2>
		<?php _e( 'Ajax Private Messages Options', 'emiPrivateMessages' ); ?>
	</h2>

	<div style="width: 600px;">
		<form method="post" action="options.php">

			<?php
			settings_fields( 'emiPrivateMessages_option_group' );
			echo '<h3>', __( 'Pager options', 'emiPrivateMessages' ), ':</h3>';

			?>
			<table class="form-table">
				<tr>
					<th><?php _e( 'Dialogs per page (inbox)', 'emiPrivateMessages' ); ?>
					</th>
					<td><input type="text" name="emiPrivateMessages[dialogsPerPage]"
						value="<?php echo $t_control->options['dialogsPerPage']; ?>" />
					</td>
				</tr>
				<tr>
					<th><?php _e( 'Messages per page (dialog)', 'emiPrivateMessages' ); ?>
					</th>
					<td><input type="text" name="emiPrivateMessages[messagesPerPage]"
						value="<?php echo $t_control->options['messagesPerPage']; ?>" />
					</td>
				</tr>
			</table>
			<?php 
			echo '<h3>', __( 'Ajax engine options', 'emiPrivateMessages' ), ':</h3>';?>
			<table class="form-table">
				<tr>
					<th><?php _e('Check for new message interval(inbox)', 'emiPrivateMessages' ); ?>
					</th>
					<td><input type="text"
						name="emiPrivateMessages[newInboxMessageInterval]"
						value="<?php echo $t_control->options['newInboxMessageInterval']; ?>" />
					</td>
				</tr>
				<tr>
					<th><?php _e( 'Check for new message interval(dialog)', 'emiPrivateMessages' ); ?>
					</th>
					<td><input type="text"
						name="emiPrivateMessages[newDialogMessageInterval]"
						value="<?php echo $t_control->options['newDialogMessageInterval']; ?>" />
					</td>
				</tr>
			</table>


			<p class="submit">
				<input type="submit" name="submit" class="button-primary"
					value="<?php _e('Save Changes', 'emiPrivateMessages' ) ?>" />
			</p>

		</form>

	</div>
	<div style="border: 1px solid #ccc; padding: 2px; color: grey;">
		<b>Developed by <a href="http://pikselkare.com" target="_blank">Pikselkare</a></b>
	</div>
</div>
